apiVersion: v1
kind: Namespace
metadata:
  name: trustful-voting-app-production
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: db
  name: db
  namespace: trustful-voting-app-production
spec:
  ports:
  - name: db-service
    port: 5432
    targetPort: 5432
  selector:
    app: db
  type: ClusterIP
---
apiVersion: v1
kind: Service
metadata:
  name: external-lb
  namespace: trustful-voting-app-production
spec:
  ports:
  - name: vote
    port: 5000
    targetPort: vote
  - name: result
    port: 5001
    targetPort: result
  selector:
    lbtype: external
  type: LoadBalancer
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: redis
  name: redis
  namespace: trustful-voting-app-production
spec:
  ports:
  - name: redis-service
    port: 6379
    targetPort: 6379
  selector:
    app: redis
  type: ClusterIP
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: result
  name: result
  namespace: trustful-voting-app-production
spec:
  ports:
  - port: 5001
    protocol: TCP
    targetPort: 80
  selector:
    app: result
  type: NodePort
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: vote
  name: vote
  namespace: trustful-voting-app-production
spec:
  ports:
  - port: 5000
    protocol: TCP
    targetPort: 80
  selector:
    app: vote
  type: NodePort
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: db
  name: db
  namespace: trustful-voting-app-production
spec:
  replicas: 1
  selector:
    matchLabels:
      app: db
  template:
    metadata:
      labels:
        app: db
    spec:
      containers:
      - env:
        - name: POSTGRES_USER
          value: postgres
        - name: POSTGRES_PASSWORD
          value: postgres
        image: postgres:15-alpine
        name: postgres
        ports:
        - containerPort: 5432
          name: postgres
        resources:
          limits:
            cpu: 125m
            memory: 128Mi
          requests:
            cpu: 70m
            memory: 64Mi
        volumeMounts:
        - mountPath: /var/lib/postgresql/data
          name: db-data
      volumes:
      - emptyDir: {}
        name: db-data
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: redis
  name: redis
  namespace: trustful-voting-app-production
spec:
  replicas: 1
  selector:
    matchLabels:
      app: redis
  template:
    metadata:
      labels:
        app: redis
    spec:
      containers:
      - image: redis:alpine
        name: redis
        ports:
        - containerPort: 6379
          name: redis
        resources:
          limits:
            cpu: 125m
            memory: 256Mi
          requests:
            cpu: 70m
            memory: 200Mi
        volumeMounts:
        - mountPath: /data
          name: redis-data
      volumes:
      - emptyDir: {}
        name: redis-data
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: result
  name: result
  namespace: trustful-voting-app-production
spec:
  replicas: 1
  selector:
    matchLabels:
      app: result
      lbtype: external
  template:
    metadata:
      labels:
        app: result
        lbtype: external
    spec:
      containers:
      - image: registry.gitlab.com/kkk1204313/abc/technology/trustful-voting-app/result:latest
        name: result
        ports:
        - containerPort: 80
          name: result
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: vote
  name: vote
  namespace: trustful-voting-app-production
spec:
  replicas: 1
  selector:
    matchLabels:
      app: vote
      lbtype: external
  template:
    metadata:
      labels:
        app: vote
        lbtype: external
    spec:
      containers:
      - image: registry.gitlab.com/kkk1204313/abc/technology/trustful-voting-app/vote:latest
        name: vote
        ports:
        - containerPort: 80
          name: vote
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: worker
  name: worker
  namespace: trustful-voting-app-production
spec:
  replicas: 1
  selector:
    matchLabels:
      app: worker
  template:
    metadata:
      labels:
        app: worker
    spec:
      containers:
      - image: registry.gitlab.com/kkk1204313/abc/technology/trustful-voting-app/worker:latest
        name: worker
        resources:
          limits:
            cpu: 100m
            memory: 128Mi
          requests:
            cpu: 70m
            memory: 64Mi
